<template>
  <div>
    <q-select
      v-model="field.config.collection"
      stack-label="Collection"
      inverted-light
      color="white"
      :options="availableCollections"
      :filter="availableCollections.length > 10"
      :disable="isLoadingCollections"
    />
    <q-select
      v-model="field.config.editor"
      stack-label="Editor"
      inverted-light
      color="white"
      :options="availableEditors"
      :filter="availableEditors.length > 10"
      :disable="isLoadingCollectionConfig || !collectionConfig"
      class="q-mt-md"
      clearable
    />
    <q-input
      v-model="field.config.editorWidth"
      stack-label="Editor width"
      inverted-light
      color="white"
      :disable="field.config.editor === null"
      type="number"
      :min="0"
      :max="100"
      :step="1"
      class="q-mt-md"
      suffix="%"
    />
    <q-color
      v-model="field.config.editorColor"
      stack-label="Editor color"
      inverted-light
      color="white"
      format-model="hex"
      :disable="field.config.editor === null"
      class="q-mt-md"
    />
    <q-input
      v-model="field.config.tableWidth"
      stack-label="Table width"
      inverted-light
      color="white"
      type="number"
      :min="0"
      :max="100"
      :step="1"
      class="q-mt-md"
      suffix="%"
    />
    <q-color
      v-model="field.config.tableColor"
      stack-label="Table color"
      inverted-light
      color="white"
      format-model="hex"
      class="q-mt-md"
    />
  </div>
</template>

<script>
  import endpointsMixin from '../../../../../../../mixins/endpointsMixin';

  export default {
    name: 'childrenField',
    mixins: [endpointsMixin],
    props: {
      field: {
        type: Object,
      },
    },
    computed: {
      availableEditors() {
        return this.collectionConfig ? this.collectionConfig.editors.map(({ title: label }, value) => ({
          value,
          label,
        })) : [];
      },
    },
    created() {
      this.loadCollections();
      if (this.field.config.collection) {
        this.loadCollectionConfig();
      }
    },
    watch: {
      // eslint-disable-next-line func-names
      'field.config.collection': function (collection, oldCollection) {
        if (collection) {
          if (oldCollection) {
            this.field.config.editor = null;
          }
          this.$nextTick(() => {
            this.loadCollectionConfig();
          });
        }
      },
    },
    data() {
      return {
        availableCollections: [],
        isLoadingCollections: false,

        collectionConfig: null,
        isLoadingCollectionConfig: false,
      };
    },
    methods: {
      loadCollectionConfig() {
        this.isLoadingCollectionConfig = true;

        this.fetchCollection(this.field.config.collection)
          .then((res) => {
            this.collectionConfig = res;
            this.isLoadingCollectionConfig = false;
          });
      },
      loadCollections() {
        this.isLoadingCollections = true;
        this.fetchCollections()
          .then((results) => {
            this.isLoadingCollections = false;
            this.availableCollections = results.map(({ collection_id: value }) => ({
              value,
              label: value,
            }));
          });
      },
    },
  };
</script>
